#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#-->                                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 06/30/03                       <--#
#-->  V Pucknell  2005
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> device_ctrl.tcl                                         <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc input_media args {
 global input_type idf imedia
    
    set input_type $args

    :modify TDEVICE :inactive F
    :modify BBROWSEDEV :inactive F

    if { $input_type == "Tape" } then {
    :modify TDEVICE :label "Drive"
    :modify TDEVICE :value ""
    :modify BIMEDIADATA :label "Tape Info"
    :modify BIMEDIADATA :inactive F
    :modify STATED :label "Not Selected"
    set imedia 0
    } elseif { $input_type == "Disc" } then {
    :modify TDEVICE :label "Disk File"
    :modify TDEVICE :value ""
    :modify TDEVICE :inactive T
    :modify BIMEDIADATA :label "Disk Info"
    :modify BIMEDIADATA :inactive F
    :modify BBROWSEDEV :inactive T
    :modify STATED :label "Not Selected"
    set imedia 1
    } elseif { $input_type == "Online"} then {
    :modify TDEVICE :value ""
    :modify TDEVICE :label ""
    :modify TDEVICE :inactive T
    :modify BBROWSEDEV :inactive T
    :modify BIMEDIADATA :inactive T
    set imedia 2
##--> We should check to see that the Tape server is actually running ...
    set rc [catch { exec ts_status_midas_sort } m]
    :modify STATED :label $m
    } elseif { $input_type == "GANILOnline"} then {
    :modify TDEVICE :value ""
    :modify TDEVICE :label ""
    :modify TDEVICE :inactive T
    :modify BBROWSEDEV :inactive T
    :modify BIMEDIADATA :inactive T
    set imedia 3
##--> We should check to see that the Tape server is actually running ...
#    set rc [catch { exec ts_status_midas_sort } m]
    :modify STATED :label "Unchecked"
    }

}

#--> Let us browse for a suitable device
proc input_browse_device args {
 global input_type idf dclist directory
    set dclist ""

    if { $input_type == "Tape" } then {
    set frame          bbrowse
    set frametitle     "Input File Browser"
    set ext            "n"
    for {set d 0} {$d < 4} {incr d} {lappend dclist /dev/rmt/$d$ext}

    :frame dcbrowse :label $frametitle :show-footer T \
         :resize F
    :panel DCP1 :layout V :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 5
     :message DCTitle :label "Input Device Browser" :bold T
     :next-row T
     :list DCLIST :strings $dclist :w 300 :rows 10 :exclusive T :command in_list
     :next-row T
    :show T
    } elseif { $input_type == "Disc" } then {
    option add *Canvas.background  #c0c020
    set types {
        {{All Files}  *}
    }
    set file [tk_getOpenFile -parent [self frame-name] \
        -title "Input SortFile Selection"  \
        -initialdir $directory -filetypes $types]
    if {$file == ""} then {return}

    set_directory [file dirname $file]   ;#  remember current choice

    set idf $file
    :modify TDEVICE :value $idf
    }
}


#--> What hapens when we have chosen our device
proc in_list {w vl} {
  global input_type idf dclist

  set idf $vl
  :modify TDEVICE :value $idf

#--> What is the status of this drive ....?                <--#
    set rc [catch { exec tapestatus_midas_sort $idf } m]
    :modify STATED :label $m
}


#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> out_device_ctrl.tcl                                     <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc click-csmediao args {
 global output_typeo idf

 set output_typeo $args

 switch $output_typeo {
     2 { :modify TDEVICEO :label "File" }
 }

}

#--> Let us browse for a suitable device
proc click-bbrowsedevo args {
 global output_typeo odf odclist directory

    if { $output_typeo != 2 } then {
    set frame          bbrowseo
    set frametitle     "Output File Browser"

    for {set d 0} {$d < 16} {incr d} {lappend odclist rst$d}
    if { $output_typeo == 2 } then {
        set odclist " "
    }

    :frame dcbrowseo :label $frametitle :show-footer T \
         :resize F
    :panel ODCP1 :layout V :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 5
     :message ODCTitle :label "Output Device Browser" :bold T
     :next-row T
     :list ODCLIST :strings $odclist :w 300 :rows 10 :exclusive T 
     :next-row T
    :show T
    } else {
    option add *Canvas.background  #c0c020
    set types {
        {{All Files}  *}
    }
    set file [tk_getOpenFile -parent [self frame-name] \
        -title "Input SortFile Selection"  \
        -initialdir $directory -filetypes $types]
    if {$file == ""} then {return}

    set odf $file
    :modify TDEVICEO :value $odf
    }
}

#--> What hapens when we have chosen our device
proc click-odclist args {
  global output_typeo odf odclist

  set odf $args
  :modify TDEVICEO :value $odf

}

#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#
#--> MIDAS interface for Sunsort                             <--#
#-->                                                         <--#
#--> Tape Info frame                                         <--#
#-->                                                         <--#
#--> D. Appelbe Daresbury NPG 04/28/03                       <--#
#-->                                                         <--#
#--> +++++++++++++++++++++++++++++++++++++++++++++++++++++++ <--#

proc tape_info {} {
    global imedia ifmt numitapes imedianum simedianame
    global imediahdr imediavals
    global dtext atext ffmt bfmt startitape tfctr

#--> Tape in use as input device
    :frame FIMEDIA :label "MIDASsort: Tape file info" \
        :icon-name "MIDASsort: Tape file info" :resize F \
        :transient T
     :panel PIMEDIA :layout V :padx 5 :pady 5
      :layout H
      :message MIMEDIAT :label "MIDASsort: Tape file info" :bold T
      :next-row T
      :next-row T
      :number NIMEDIATAPES :label "Number of Tapes to Scan" :min 1 \
          :max 30 :value $numitapes :w 3
    if { $ifmt == 1 } then {
#--> We have ansi format tapes we need to know what not to read
        :next-row T
        :message MIMEDIA :label "Use the form below to decide which runfiles to IGNORE"
        :next-row T
        :next-row T
        :layout H
        :next-row T
        :next-row T
        :panel PIMDIA2 :layout L :padx 5 :pady 5
         :layout V
         :list IMEDIALIST :cols 15 :rows 10 :exclusive T :see 0 \
             :scroll V :strings $imediahdr
        :panel PIMDIA2A :layout L :padx 5 :pady 5
         :layout H
        :number NIMEDIAVAL :label "Tape Number" :min 1 :max 20 \
            :value $imedianum :w 3
        :next-row T
        :hskip 20
        :text TIMEDIANAME :label "File Name" :value $simedianame :w 6
        :next-row T
        :button BIMEDIAADD    :label "Add"     :w 7  :command add-imedia
        :button BIMEDIAREMOVE :label "Remove"  :w 7  :command remove-imedia
        :next-row T
        :button BIMEDIAOK     :label "All Set" :w 7  :command ok-imedia
        } elseif { $ifmt == 1 } then {
        :hskip 25
        :button BIMEDIAOK :label "All Set" :w 7  :command ok-imedia
    }
    :show T
}

#--> Here are the routines that are used by the tape portion of our GUI
proc paint-imedialist {} {
    global imediahdr imediavals imediaselect

    set mylist $imediahdr

    foreach v $imediavals { lappend mylist $v }

    :modify IMEDIALIST :empty T :strings $mylist
    :modify IMEDIALIST :select $imediaselect
}

proc add-imedia {} {
    global imediahdr imediavals imediaselect
    global numitapes imedianum simedianame

    set fred [ format "%3d   %6s" $imedianum $simedianame ]
    lappend imediavals $fred
    
    paint-imedialist

}

proc ok-imedia {} {
    global imediahdr imediavals imediaselect
    global numitapes imedianum simedianame ifmt

    if { $numitapes < 1 } then {
    midas-warning "Incorrect number of tapes specified ($numitapes)\n"
    return
    }

    set z [ catch { open "tape.info" w } f ]
    if {$z != 0} then {
    midas-warning "Unable to write file $sortfilename\n$f"
    return
    } else {
    puts $f "$ifmt"
    puts $f "$numitapes"
    foreach v $imediavals { puts $f "$v" }
    }
    close $f
    midas-report "Data saved ok ...\n"

    :modify STATED :label "Files input"

    set numitapes 0
    
    destroy-frame FIMEDIA

}

proc choice-imedia {s} {
    global imediaselect

    if { $s > 0 } then {
    set imediaselect $s
    }

    :modify IMEDIALIST :select $imediaselect

}

proc remove-imedia {} {
    global imediaselect imediavals tfctr

    if { $imediaselect > 0 } then {
    set imediaselect [expr { $imediaselect - 1 } ]
    set imediavals [ lreplace [K $imediavals [set imediavals {}]] $imediaselect $imediaselect ]
    set imediaselect -1
    set tfctr [ expr { $tfctr - 1 } ]
    paint-imedialist
    }

}

#--> ======================================================== <--#
#--> The control routines ...                                 <--#
#--> ======================================================== <--#
proc paint-disklist {} {
    global list_select list_vals

    set mylist {}
    
    foreach v $list_vals { lappend mylist $v }

    :modify LDISK :empty T :strings $mylist
    :modify LDISK :select $list_select

}

#--> ======================================================== <--#
proc save-diskvalues {} {
    global mydegbug
    global tfctr
    global list_vals

    if { $tfctr > 0 } then {
    set z [ catch { open "disc.info" w } f ]
    if {$z != 0} then {
        midas-warning "Unable to write file disc.info\n$f"
        return
    } else {
        puts $f "$tfctr"
        foreach v $list_vals { puts $f "$v" }
    }
    close $f

    :modify STATED :label "Files input"
    
    destroy-frame FDISK
    
    }

  UpdateRunState

}

#--> ======================================================== <--#
proc load-diskvalues {} {
    global mydebug
    global list_vals
    global tfctr

    set text ""
    set bs   ""
    
    if { $tfctr == 0 } then {
    if { $mydebug == 1 } then {
        puts "Checking for disk.info"
    }
    
    set z [ catch { open "disc.info" r } f ]
    if { $z == 0 } then {
        if { $mydebug == 1 } then {
        puts "Opened file succesfully"
        }
        gets $f tfctr
        if { $mydebug == 1 } then {
        puts "There are $tfctr values to read"
        }
        set list_vals {}
        set wilma ""
        for { set i 0 } { $i < $tfctr } { incr i } {
        gets $f wilma
        lappend list_vals $wilma
        if { $mydebug == 1 } then {
            puts "Just read $wilma"
        }
        }
        close $f
    } else {
        if { $mydebug == 1 } then {
        puts "The file does not exist"
        }
        
    }
    }

}

#--> ======================================================== <--#
proc add-list {} {
    global dtext
    global atext
    global dstart
    global dstop
    global diskffmt
    global bfmt
    global list_vals
    global tfctr

    if {$dtext == ""} {set-footer FDISK "Warning - null file name"; return}
    clear-footer FDISK

    if { $diskffmt == 0 } then {
    if { $dstart <= $dstop } then {
        for { set i $dstart } { $i <= $dstop } { incr i } {
        set fred  [ format "%s%i        %i" $dtext $i $bfmt ]
        set tfctr [ expr { $tfctr + 1 } ]
        lappend list_vals $fred
        }
    } else {
        set fred  [ format "%s%i        %i" $dtext $dstart $bfmt ]
        set tfctr [ expr { $tfctr + 1 } ]
        lappend list_vals $fred
    }
    } elseif { $diskffmt == 1 } then {
    if { $dstart <= $dstop } then {
        for { set i $dstart } { $i <= $dstop } { incr i } {
        set fred  [ format "%s%i%s        %i" $dtext $i $atext $bfmt ]
        set tfctr [ expr { $tfctr + 1 } ]
        lappend list_vals $fred
        }
    } else {
        set fred  [ format "%s%i%s        %i" $dtext $dstart $atext $bfmt ]
        set tfctr [ expr { $tfctr + 1 } ]
        lappend list_vals $fred
    }
    } else {
    set fred  [ format "%s        %i" $dtext $bfmt ]
    set tfctr [ expr { $tfctr + 1 } ]
    lappend list_vals $fred
    }

    set dstart 0
    set dstop  1
    set dtext  ""
    set atext  ""
    
    :modify NDISK  :value $dstart
    :modify NDISK1 :value $dstop
    :modify TDISK  :value $dtext
    :modify TDISK1 :value $atext

    paint-disklist

}

#--> ======================================================== <--#
proc remove-list {} {
    global list_select
    global tfctr
    global list_vals

    set list_vals [ lreplace [K $list_vals [set list_vals {}]] $list_select $list_select ]
    set list_select -1
    set tfctr [ expr { $tfctr - 1 } ]
    paint-disklist

}

#--> ======================================================== <--#
proc clear-disklist { } {
    global list_vals
    global tfctr

    set list_vals [ lreplace [K $list_vals [set list_vals {}]] 0 $tfctr ]
    set list_select -1
    set tfctr 0
    paint-disklist


}

#--> ======================================================== <--#
proc select-item { s } {
    global list_select
    global mydebug

    set list_select $s

    :modify LDISK :select $list_select

    if { $mydebug == 1 } then {
    puts $list_select
    }

}

#--> ======================================================== <--#
proc ndisk {w vl} {
    global dstart

    set dstart $vl
    :modify NDISK :value $dstart
}

#--> ======================================================== <--#
proc ndisk1 {w vl} {
    global dstop

    set dstop $vl
    :modify NDISK1 :value $dstop
}

#--> ======================================================== <--#
proc csdisk arg {
    global diskffmt

    set diskffmt $arg

    if { $diskffmt <= 1 } then {
    :modify TDISK1 :inactive F
    :modify NDISK  :inactive F
    :modify NDISK1 :inactive F
    } else {
    :modify TDISK1 :inactive T
    :modify NDISK  :inactive T
    :modify NDISK1 :inactive T
    }

    SavePreferences

}

#--> ======================================================== <--#
proc browse_disk_files {} {
    global sortdatadir
    global dtext

    option add *Canvas.background  #c0c020

    set file [tk_getOpenFile -parent [self frame-name] \
          -title "Input DataFile Selection"  \
          -initialdir $sortdatadir ]
#    option add *Canvas.background  $env(tkcanvasbackground)
    if {$file == ""} then {return}

    set_sortdatadir W [file dirname $file]   ;#  remember current choice

    set dtext $file
    :modify TDISK :value $dtext
#    [:path TDISK].entry xview 200

}

#--> ======================================================== <--#
#--> The procedure that sets up the GUI                       <--#
#--> ======================================================== <--#
proc disk_info {} {
    global imedia ifmt numitapes imedianum simedianame
    global imediahdr imediavals
    global dtext atext diskffmt bfmt startitape tfctr dstart dstop


    load-diskvalues

    set filefmt [ list "text number" "text number text" "custom" "MIDAS"] 
    set blksize [ list 1024 2048 4096 8192 16384 32768 65536 ] 

    :frame FDISK :label "MIDASsort: Disk Info" \
    :resize F \
    :transient T
    :panel PDISK :layout V :padx 5 :pady 5
    :layout H
    :message MDISK :label "DISK Info:" :bold T
    :hskip 5
    :message MDISK1 :label "Use this frame generate the file containing information about the input disk files to scan" :colour "-fg black"
    :next-row T
    :next-row T
    :list LDISK :cols 70 :rows 20 :exclusive T :see 0 :scroll V
    :next-row T
    :panel PDISK2 :layout V :padx 5 :pady 5
    :layout H
    :choice-stack CSDISK :label "Name Format" :strings $filefmt :value $diskffmt
    :hskip 40
    :number NDISK  :label "Start at" :min 0 :max 500 :value $dstart :w 3 :command ndisk
    :hskip 5
    :number NDISK1 :label "Stop at"  :min 0 :max 500 :value $dstop  :w 3 :command ndisk1
    :hskip 20
    :choice-stack CSDISK1 :label "Block size" :strings $blksize :value 5
    :panel PDISK3 :layout V :padx 5 :pady 5
    :layout H
    :text TDISK :label "Text" :w 35 :shifters T :value $dtext
    :hskip 25
    if { $diskffmt == 1 } then {
    :text TDISK1 :label "Append text" :w 8 :shifters T :inactive F :value $atext
    } elseif { $diskffmt > 1 } {
    :text TDISK1 :label "Append text" :w 8 :shifters T :inactive T
    :modify NDISK  :inactive T
    :modify NDISK1 :inactive T
    } else {
    :modify NDISK  :inactive F
    :modify NDISK1 :inactive F
    :text TDISK1 :label "Append text" :w 8 :shifters T :inactive T
    }
    :hskip 20
    :button BDISK6 :label "Browse" :w 10  :command browse_disk_files
    :panel PDISK1 :layout V :padx 5 :pady 5
    :layout H
    :button BDISK0 :label "Add" :w 10  :command add-list
    :hskip 10
    :button BDISK1 :label "Redisplay" :w 10  :command paint-disklist
    :hskip 10
    :button BDISK2 :label "Remove" :w 10  :command remove-list
    :hskip 10
    :button BDISK3 :label "Clear" :w 10   :command clear-disklist
    :hskip 10
    :button BDISK4 :label "Save & Quit" :w 10 :command save-diskvalues
    :hskip 10
    :button BDISK5 :label "Cancel" :w 10  :command "destroy-frame FDISK"
    :hskip 10
    :next-row T

    :show T

    paint-disklist

}

